#ifndef __ANFIBIOEXOTICO_H__
#define __ANFIBIOEXOTICO_H__

#include "anfibio.h"
#include "animalexotico.h"


/* @brief Classe Anfibio, que modela um  Anfíbio do tipo Exotico, que toma Anfibio e AnimalExotico
*				  como classes pai a herdar seus atributos
* @param 	Métodos públicos:
*					friend std::ostream& operator<< (std::ostream &output, AnfibioExotico const anfexo) Sobrecarga do operador de inserção para animal do tipo AnfibioExotico
*					AnfibioExotico - Construtor cria um animal do tipo AnfíbioExotico
*
*/
class AnfibioExotico: public Anfibio, AnimalExotico {
	private:

	public:
		friend std::ostream& operator<< (std::ostream &output, AnfibioExotico const anfexo);
		AnfibioExotico(int identity, string clas, string name, string scientific, char sex, float size,
    				string diet, string baptism, Veterinario vet, Tratador caretaker,
    				int total_changes, string last_change, string biernr, string origin_country);
    AnfibioExotico();

};

#endif
