#include "anfibionativo.h"

/**
* @brief Sobrecarga do operador de inserção para animal do tipo AnfibioNativo
* @param  output - stream de saida
*         anfnat - Objeto do tipo AnfibioNativo
*
*/

std::ostream& operator<< (std::ostream &output, AnfibioNativo const &anfnat) {
	output << anfnat.id >> ";" << anfnat.classe << ";" << anfnat.nome << ";" << anfnat.cientifico << ";" <<
	 	anfnat.sexo << ";" << anfnat.tamanho << ";" << anfnat.dieta << ";" << anfnat.batismo  << ";" << anfnat.veterinario
     << ";" << anfnat.tratador << ";" << anfnat.total_mudas << ";" << anfnat.ultima_muda << ";"
     << anfnat.ibama << ";" << anfnat.uf_origem << ";" << anfnat.autorizacao;

	return output;

	}

  /**
  * @brief Construtor cria um animal do tipo AnfíbioNativo, que toma Anfibio,
	*  				e AnimalNativo como classe pai a herdar seus atributos
  * @param identity - ID, clas - classe do animal, name - nome do animal, scientific - nome científico do animal,
  *					sex - sexo do animal, size - tamanho do animal, diet - dieta do animal,
  * 				baptism - nome de batismo do animal, vet - veterinário associado ao animal,
  *					caretaker - tratador associado ao animal, total_changes - número de mudas do animal,
  *					last_change - ultima muda do animal, biernr - ibama, origin_state - estado de origem do animal,
  *         authorization - autorização do animal
  */
AnfibioNativo::AnfibioNativo(int identity, string clas, string name, string scientific, char sex, float size,
        string diet, string baptism, Veterinario vet, Tratador caretaker,int total_changes,
        string last_change, string biernr, string origin_state, string authorization):

        Anfibio(identity, clas, name, scientific, sex, size, diet, baptism, vet, caretaker, total_changes, last_change),
        AnimalNativo(biernr, origin_state, authorization)
        {}
}
