#include "mamifero.h"

/**
* @brief Construtor cria um animal do tipo Mamifero, que toma Animal como classe pai a herdar seus atributos
* @param identity - ID, clas - classe do animal, name - nome do animal, scientific - nome científico do animal,
*					sex - sexo do animal, size - tamanho do animal, diet - dieta do animal,
* 				baptism - nome de batismo do animal, vet - veterinário associado ao animal,
*					caretaker - tratador associado ao animal, fur_color - cor do pelo
*
*/
Mamifero::Mamifero(int identity, string clas, string name, string scientific, char sex,
					float size, string diet, string baptism, Veterinario vet, Tratador caretaker, string fur_color):

				Animal(identity, clas, name, scientific, sex, size, diet, baptism, vet, caretaker),

				cor_pelo(fur_color)


{}

/**
* @brief Funcao que retorna a cir di oeki
* @return Cor do pelo
*/
string Mamifero::getCor_pelo(){
	return cor_pelo;
}

/**
* @brief Funcao que modifica a cor do pelo
* @param fur_color Cor do pelo
*/

void Mamifero::setCor_pelo(string fur_color){
	cor_pelo = fur_color;
}
