#include "reptil.h"


/**
* @brief Construtor cria um animal do tipo Reptil, que toma Animal como classe pai a herdar seus atributos
* @param identity - ID, clas - classe do animal, name - nome do animal, scientific - nome científico do animal,
*					sex - sexo do animal, size - tamanho do animal, diet - dieta do animal,
* 				baptism - nome de batismo do animal, vet - veterinário associado ao animal,
*					caretaker - tratador associado ao animal, isPoisonous - estado do animal ser venenoso ou não,
*					tipo_veneno - tipo do veneno do animal
*
*/
Reptil::Reptil(int identity, string clas, string name, string scientific, char sex, float size,
				string diet, string baptism, Veterinario vet, Tratador caretaker,
				bool isPoisonous, string poison_type):

				Animal(identity, clas, name, scientific, sex, size, diet, baptism, vet, caretaker),

				venenoso(isPoisonous), tipo_veneno(poison_type)


{}

/**
* @brief Funcao que retorna o estado de venenoso do animal
* @return É venenoso/não é venenoso
*/
bool Reptil::getVenenoso(){
	return venenoso;
}

/**
* @brief Funcao que modifica o estado de venenoso do animal
* @param isPoisonous se é ou não venenoso
*/
void Reptil::setVenenoso(bool isPoisonous){
	venenoso = isPoisonous;
}

/**
* @brief Funcao que retorna tipo de veneno
* @return Tipo de veneno
*/
string Reptil::getTipo_veneno(){
	return tipo_veneno;
}

/**
* @brief Funcao que modifica o tipo de veneno
* @param poison_type Tipo de veneno
*/
void Reptil::setTipo_veneno(string poison_type){
	tipo_veneno = poison_type;
}
